/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"bytes"
	"encoding/json"
	"fmt"
)

// checks if the PasswordChangeRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &PasswordChangeRequest{}

// PasswordChangeRequest struct for PasswordChangeRequest
type PasswordChangeRequest struct {
	OldPassword string `json:"oldPassword"`
	NewPassword string `json:"newPassword"`
}

type _PasswordChangeRequest PasswordChangeRequest

// NewPasswordChangeRequest instantiates a new PasswordChangeRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPasswordChangeRequest(oldPassword string, newPassword string) *PasswordChangeRequest {
	this := PasswordChangeRequest{}
	this.OldPassword = oldPassword
	this.NewPassword = newPassword
	return &this
}

// NewPasswordChangeRequestWithDefaults instantiates a new PasswordChangeRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPasswordChangeRequestWithDefaults() *PasswordChangeRequest {
	this := PasswordChangeRequest{}
	return &this
}

// GetOldPassword returns the OldPassword field value
func (o *PasswordChangeRequest) GetOldPassword() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OldPassword
}

// GetOldPasswordOk returns a tuple with the OldPassword field value
// and a boolean to check if the value has been set.
func (o *PasswordChangeRequest) GetOldPasswordOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OldPassword, true
}

// SetOldPassword sets field value
func (o *PasswordChangeRequest) SetOldPassword(v string) {
	o.OldPassword = v
}

// GetNewPassword returns the NewPassword field value
func (o *PasswordChangeRequest) GetNewPassword() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.NewPassword
}

// GetNewPasswordOk returns a tuple with the NewPassword field value
// and a boolean to check if the value has been set.
func (o *PasswordChangeRequest) GetNewPasswordOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.NewPassword, true
}

// SetNewPassword sets field value
func (o *PasswordChangeRequest) SetNewPassword(v string) {
	o.NewPassword = v
}

func (o PasswordChangeRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o PasswordChangeRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["oldPassword"] = o.OldPassword
	toSerialize["newPassword"] = o.NewPassword
	return toSerialize, nil
}

func (o *PasswordChangeRequest) UnmarshalJSON(data []byte) (err error) {
	// This validates that all required properties are included in the JSON object
	// by unmarshalling the object into a generic map with string keys and checking
	// that every required field exists as a key in the generic map.
	requiredProperties := []string{
		"oldPassword",
		"newPassword",
	}

	allProperties := make(map[string]interface{})

	err = json.Unmarshal(data, &allProperties)

	if err != nil {
		return err
	}

	for _, requiredProperty := range requiredProperties {
		if _, exists := allProperties[requiredProperty]; !exists {
			return fmt.Errorf("no value given for required property %v", requiredProperty)
		}
	}

	varPasswordChangeRequest := _PasswordChangeRequest{}

	decoder := json.NewDecoder(bytes.NewReader(data))
	decoder.DisallowUnknownFields()
	err = decoder.Decode(&varPasswordChangeRequest)

	if err != nil {
		return err
	}

	*o = PasswordChangeRequest(varPasswordChangeRequest)

	return err
}

type NullablePasswordChangeRequest struct {
	value *PasswordChangeRequest
	isSet bool
}

func (v NullablePasswordChangeRequest) Get() *PasswordChangeRequest {
	return v.value
}

func (v *NullablePasswordChangeRequest) Set(val *PasswordChangeRequest) {
	v.value = val
	v.isSet = true
}

func (v NullablePasswordChangeRequest) IsSet() bool {
	return v.isSet
}

func (v *NullablePasswordChangeRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePasswordChangeRequest(val *PasswordChangeRequest) *NullablePasswordChangeRequest {
	return &NullablePasswordChangeRequest{value: val, isSet: true}
}

func (v NullablePasswordChangeRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePasswordChangeRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
